unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLScene, GLObjects, GLCoordinates, GLCrossPlatform, BaseClasses,
  GLWin32Viewer, Menus, StdCtrls, GLColor;

type

  Molecula = Record
    nom : string;
    NA  : integer;
    AC  : array of array[0..2] of single;
    AN  : array of string[4];
  End;

  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLDummyCube1: TGLDummyCube;
    MainMenu1: TMainMenu;
    Molecula1: TMenuItem;
    Abrir1: TMenuItem;
    Visualiza1: TMenuItem;
    Esferas1: TMenuItem;
    Button1: TButton;
    procedure Abrir1Click(Sender: TObject);
    procedure Esferas1Click(Sender: TObject);
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    Mol   : Molecula;
    px,py : integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X;
  py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X; py := Y;
  end;
end;

procedure TForm1.Abrir1Click(Sender: TObject);
var
  fid   : TextFile;
  kk,jj : integer;
  noma  : string;
  cdum  : string[6];
  d1,d2 : integer;
begin
  noma := 'jasmone.pdb';
  AssignFile(fid,noma);
  Reset(fid);

  readln(fid,cdum, Mol.nom);
  for kk := 0 to 2 do readln(fid,cdum);

  kk := 0;
  repeat
    read(fid,cdum);
    if cdum[1]='H' then begin
      inc(kk);
      SetLength(Mol.AC,kk);
      SetLength(Mol.AN,kk);

      read(fid,d1);
      read(fid,Mol.AN[kk-1]);
      read(fid,d2);
      for jj := 0 to 2 do read(fid,Mol.AC[kk-1][jj]);
      readln(fid);
    end;
  until cdum[1]<>'H';
  Mol.NA := kk;

  closeFile(fid);
end;

procedure TForm1.Esferas1Click(Sender: TObject);
var
  kk   : integer;
  Bol  : TGLSphere;
begin
  for kk := 0 to Mol.NA-1 do begin
    Bol := TGLSphere.Create(self);
    Bol.Radius := 0.15;
    Bol.Position.SetPoint(Mol.AC[kk][0],
                          Mol.AC[kk][1],
                          Mol.AC[kk][2]);

    GLScene1.Objects.AddChild(Bol);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Lin : TGLLines;
begin
  Lin := TGLLines.Create(self);
  Lin.NodesAspect := lnaInvisible;
  Lin.LineWidth := 3;
  Lin.LineColor.Color := clrBlue;
  with Mol do begin
    Lin.Nodes.AddNode(AC[0][0],AC[0][1],AC[0][2]);
    Lin.Nodes.AddNode(AC[1][0],AC[1][1],AC[1][2]);
  end;
  GLScene1.Objects.AddChild(Lin);

end;



end.
